﻿using UnityEngine;
using System.Collections;

public class AudioTrigger : MonoBehaviour {

	public int sourceID;
	private string sourceReference;		//playerpref for the specific trigger

	private AudioSource source;
	private bool play;

	// Use this for initialization
	void Start () {
		source = GetComponent<AudioSource>();
		sourceReference = Application.loadedLevelName+"/"+sourceID;
		play = false;

		if (PlayerPrefs.GetInt(sourceReference) != 1) {
			PlayerPrefs.SetInt(sourceReference, 0);
		}
	}

	//if player enters trigger, play the sound clip
	void OnTriggerEnter(Collider other) {
		if (other.tag == "Player" && PlayerPrefs.GetInt(sourceReference) != 1) {
			//Debug.Log("start playing");
			source.Play();
			play = true;
		}
	}

	void Update() {
		if (play) {
			if (source.isPlaying == false) {	//check this after the clip has played
				//Debug.Log("stop playing");
				PlayerPrefs.SetInt(sourceReference, 1);
			}
		}
		//Debug.Log(PlayerPrefs.GetInt(sourceReference));
		if (Input.GetKeyDown(KeyCode.Backspace)) {
			PlayerPrefs.DeleteAll();
			Debug.Log("reset");
		}
	}
}
