﻿using UnityEngine;
using System.Collections;

public class ButtonAudioTrigger : MonoBehaviour {

	public int sourceID;
	private string sourceReference;		//playerpref for the specific trigger
	
	private AudioSource source;
	private bool canPlay;				//detect wheter the player is in range of the trigger

	// Use this for initialization
	void Start () {
		source = GetComponent<AudioSource>();
		sourceReference = Application.loadedLevelName+"/"+sourceID;
		canPlay = false;

		if (PlayerPrefs.GetInt(sourceReference) != 1) {
			PlayerPrefs.SetInt(sourceReference, 0);
		}
	}
	
	// Update is called once per frame
	void Update () {
		if (canPlay) {
			if (Input.GetKeyDown(KeyCode.F) && PlayerPrefs.GetInt(sourceReference) != 1) {
				source.Play();
				PlayerPrefs.SetInt(sourceReference, 1);
			}
		}
	}

	void OnTriggerEnter(Collider other) {
		if (other.tag == "Player") {
			canPlay = true;
		}
	}

	void OnTriggerExit(Collider other) {
		if (other.tag == "Player") {
			canPlay = false;
		}
	}
}
