﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Linq;

/*TODO
	- cone area of effect attack
	- mortar-esque attack (or ranged projectile that explodes)

	Abilitiy list:
		Level 1:
			- Fireball
			- Fire Hands
			- Push
			- Lightning bolt
			- Dodge
		Level 2:
			- Flames
			- Grounding charge
			- Improved dodge
		Level 3:
			- Firebomb
			- Lightning Slash
 */

public class PlayerAttack : MonoBehaviour {

	public Rigidbody basicProjectile;
	public Rigidbody basicProjectile2;
	public Rigidbody explosiveProjectile;

	public Text leftPower;		//left click attack
	public Text rightPower;		//right click attack

	/*public int maxLeftIndex = 1;
	public int maxRightIndex = 1;*/

	private int maxLeftIndex, maxRightIndex;

	public Vector3 mousePos;
	public Vector3 objectPos;
	public Vector3 dir;
	public float angle;
	public float speed = 3;
	private int selection, selection2;	//switching between powers
	public bool level2, level3;			//determining which abilities have unlocked
	public Transform muzzle;
	
	private Ray ray;
	private RadialMenu rm;
	private bool hitEnemy;
	private Ray hitEnemyCheck;

	private PlayerControl pc;
	
	private bool attackCooldown, attackCooldown2, attackCooldown3, attackCooldown4, attackCooldown5, attackCooldown6, 
	attackCooldown7, attackCooldown8;
	// Use this for initialization
	void Start () {
		rm = GameObject.FindGameObjectWithTag("PlayerUI").GetComponent<RadialMenu>();
		pc = GetComponent<PlayerControl>();
		pc.faceMouse = false;
		//muzzle = gameObject.GetComponentInChildren<Transform>();
		//Debug.Log(muzzle);
		selection = 0;
		selection2 = 0;

		attackCooldown = false;
		attackCooldown2 = false;
		attackCooldown3 = false;
		attackCooldown4 = false;
		attackCooldown5 = false;
		attackCooldown6 = false;
		attackCooldown7 = false;
		attackCooldown8 = false;
	}
	
	// Update is called once per frame
	void Update () {
		//get the player position form the camera
		objectPos = transform.position;
		dir = mousePos-objectPos;
		dir.Normalize();
		angle = Vector3.Angle(dir, transform.TransformDirection(Vector3.forward));
		ray = Camera.main.ScreenPointToRay(Input.mousePosition);

		//Debug.Log(selection+"||"+selection2);
		//Debug.Log("Cooldown: "+attackCooldown);

		if (level2) {
			maxLeftIndex = 2;
			maxRightIndex = 2;
		}
		else if (level2 && level3) {
			maxLeftIndex = 3;
			maxRightIndex = 3;
		}
		else {
			maxLeftIndex = 1;
			maxRightIndex = 1;
		}

		if (Input.GetKeyDown(KeyCode.Q)) {
			if (selection == maxLeftIndex) {
				selection = 0;
			}
			else {
				selection += 1;
			}
		}
		else if (Input.GetKeyDown(KeyCode.E)) {
			if (selection2 == maxRightIndex) {
				selection2 = 0;
			}
			else {
				selection2 += 1;
			}
		}

		//set the name of the power that's equiped
		if (selection == 0) {
			leftPower.text = "Fire Hands";
		}
		else if (selection == 1) {
			leftPower.text = "Push";
		}
		else if (selection == 2) {
			leftPower.text = "Flames";
		}
		else if (selection == 3) {
			leftPower.text = "Lightning Slash";
		}

		if (selection2 == 0) {
			rightPower.text = "Fireball";
		}
		else if (selection2 == 1) {
			rightPower.text = "Lightning Bolt";
		}
		else if (selection2 == 2) {
			rightPower.text = "Ground Charge";
		}
		else if (selection2 == 3) {
			rightPower.text = "Firebomb";
		}

		//if (Input.GetButtonDown("Fire1")) {
		if (!rm.menuActive) {
			if (/*Input.GetKey(KeyCode.Space) || */Input.GetButtonDown("Fire1")) {
				if (selection == 0 && attackCooldown == false) {
					attackCooldown = true;
					StartCoroutine(Cooldown(1));
					PunchAttack(100, 1, 1.0f);
					Debug.Log("Fire Hands");
				}
				else if (selection == 1 && attackCooldown2 == false) {
					attackCooldown2 = true;
					StartCoroutine(Cooldown2(1.5f));
					PunchAttack(60, 3, 1.0f);
					Debug.Log("Push");
				}
				else if (selection == 2 && attackCooldown3 == false) {
					attackCooldown3 = true;
					StartCoroutine(Cooldown3(1.5f));
					ConeAttack(40, 1, 90, 10);
					Debug.Log("Flames");
				}
				else if (selection == 3 && attackCooldown4 == false) {
					attackCooldown4 = true;
					StartCoroutine(Cooldown4(2f));
					PunchAttack(150, 2, 1.0f);
					Debug.Log("Lightning Slash");
				}

				//pc.faceMouse = true;
			}
			/*else {
				pc.faceMouse = false;
			}*/

			if (Input.GetButtonDown("Fire2") || Input.GetKeyDown(KeyCode.LeftShift)) {
				if (selection2 == 0 && attackCooldown5 == false) {
					attackCooldown5 = true;
					StartCoroutine(Cooldown5(1.5f));
					ProjectileAttack(50, 1, 1, basicProjectile, true);
					Debug.Log("Fireball");
				}
				else if (selection2 == 1 && attackCooldown6 == false) {
					attackCooldown6 = true;
					StartCoroutine(Cooldown6(3));
					RaycastAttack(50, 2);
					Debug.Log("Lighting bolt");
				}
				else if (selection2 == 2 && attackCooldown7 == false) {
					attackCooldown7 = true;
					StartCoroutine(Cooldown7(4));
					AOEAttack(30, 2);
					Debug.Log("Ground charge");
				}
				else if (selection2 == 3 && attackCooldown8 == false) {
					attackCooldown8 = true;
					StartCoroutine(Cooldown8(4));
					ProjectileAttack(40, 1, 10, explosiveProjectile, true);
					Debug.Log("Firebomb");
				}
				//pc.faceMouse = true;
			}
			/*else {
				pc.faceMouse = false;
			}*/
		}

		if (hitEnemy) {
			Debug.DrawLine(hitEnemyCheck.origin, hitEnemyCheck.direction, Color.yellow);
		}
	}

	//model for ray-based attack
	void RaycastAttack(int damage, int damageType) {
		ray = Camera.main.ScreenPointToRay(Input.mousePosition);
		Debug.DrawLine(ray.origin, ray.direction, Color.green);

		RaycastHit hit;
		RaycastHit rayHit;
		if (Physics.Raycast(ray,out hit, 100)) {	//first racast, from player to mouse position, get direction we're attacking
			Vector3 check = hit.transform.position-transform.position;
			Ray rayCheck = new Ray(transform.position+Vector3.up, hit.transform.position-transform.position);
			Debug.DrawRay(transform.position, hit.point-transform.position, Color.blue);
			hitEnemyCheck = rayCheck;
			hitEnemy = true;
			if (Physics.Raycast(muzzle.position, check, out rayHit)) {	//second raycast, see if we can hit the enemy
				if (rayHit.collider.tag == "Enemy") {	//if it's a different enemy
					RaycastHit[] hits = Physics.RaycastAll(muzzle.position, check);	//get everything along that line
					foreach (RaycastHit rh in hits.OrderBy(x => x.distance)) { //check through them by distance
						if (rh.collider.tag != "Enemy") {	//if we hit something that isn't an enemy
							Debug.Log("We hit a wall");
							break;	//exit the loop
						}
						else {
							//check which component we want
							if (rh.collider.GetComponent<EnemyHealth>() != null) {
								rh.collider.GetComponent<EnemyHealth>().Hurt(damage);
								ElementalDamage(damageType, rh.transform.gameObject.GetComponent<EnemyHealth>());
							}

							if (rh.collider.GetComponent<PropHealth>() != null) {
								if (rh.collider.GetComponent<PropHealth>().enabled == true) {
									rh.collider.GetComponent<PropHealth>().Hurt(damage);
								}
							}
							
							if (rh.collider.GetComponent<BossObjectiveHealth>() != null) {
								rh.collider.GetComponent<BossObjectiveHealth>().Hurt(damage);
								BossObjectiveElementalDamage(damageType, rh.transform.gameObject.GetComponent<BossObjectiveHealth>());
							}
							
							if (rh.collider.GetComponent<BossHealth>() != null && rh.collider.GetComponent<BossObjectiveManager>().opening) {
								rh.collider.GetComponent<BossHealth>().Hurt(damage);
								BossElementalDamage(damageType, rh.collider.GetComponent<BossHealth>());
							}
						}
					}
				}
			}
		}
	}

	//model for projectile-based attack
	void ProjectileAttack(int damage, int damageType, int radius, Rigidbody projectile, bool destroyOnHit) {
		ray = Camera.main.ScreenPointToRay(Input.mousePosition);

		RaycastHit hit;
		if (Physics.Raycast(ray,out hit, 100)) {
			//Vector3 check = hit.transform.position-objectPos;
			Vector3 check = hit.point-muzzle.position;
			check.Normalize();
			Rigidbody projInst = Instantiate(projectile, muzzle.position, Quaternion.Euler(check)) as Rigidbody;
			if (projInst.GetComponent<Projectile>() != null) {
				Projectile p = projInst.GetComponent<Projectile>();
				p.destroyOnHit = destroyOnHit;
				p.damage = damage;
				p.damageType = damageType;
			}
			else {
				ExplosiveProjectile ep = projInst.GetComponent<ExplosiveProjectile>();
				ep.damage = damage;
				ep.damageType = damageType;
				ep.radius = radius;
			}

			Vector3 projSpeed = check*speed;
			projInst.velocity = new Vector3(projSpeed.x, 0, projSpeed.z);
		}
	}

	//model for a close ranged attack
	void PunchAttack(int damage, int damageType, float cooldownTime) {
		ray = Camera.main.ScreenPointToRay(Input.mousePosition);
		Debug.DrawRay(ray.origin, ray.direction, Color.green);
		RaycastHit hit;
		RaycastHit punchHit;

		if (Physics.Raycast(ray, out hit, 100)) {
			Vector3 check = hit.transform.position-transform.position;
			if (Physics.Raycast(transform.position, check, out punchHit, 2)) {
				if (punchHit.collider.tag == "Enemy" && punchHit.collider.isTrigger == false) {
					//Debug.Log("punched");
					//check which component we want
					if (punchHit.collider.GetComponent<EnemyHealth>() != null) {
						punchHit.collider.GetComponent<EnemyHealth>().Hurt(damage);
					}
					if (punchHit.collider.GetComponent<PropHealth>() != null) {
						if (punchHit.collider.GetComponent<PropHealth>().enabled == true) {
							punchHit.collider.GetComponent<PropHealth>().Hurt(damage);
						}
					}
					if (punchHit.collider.GetComponent<BossObjectiveHealth>() != null) {
						punchHit.collider.GetComponent<BossObjectiveHealth>().Hurt(damage);
					}
					if (punchHit.collider.GetComponent<BossHealth>() != null && punchHit.collider.GetComponent<BossObjectiveManager>().opening) {
						punchHit.collider.GetComponent<BossHealth>().Hurt(damage);
						BossElementalDamage(damageType, punchHit.collider.GetComponent<BossHealth>());
					}
				}
			}
		}
	}

	//model for user-centered AOE attack
	void AOEAttack(int damage, int damageType) {
		Collider[] hits = Physics.OverlapSphere(transform.position, 10f);
		foreach (Collider c in hits) {
			if (c.tag == "Enemy" && c.isTrigger == false) { //otherwise it will return two objects
				//check which component we want
				if (c.collider.GetComponent<EnemyHealth>() != null) {
					c.collider.GetComponent<EnemyHealth>().Hurt(damage);
					ElementalDamage(damageType, c.collider.GetComponent<EnemyHealth>());
				}
				if (c.collider.GetComponent<PropHealth>() != null) {
					if (c.collider.GetComponent<PropHealth>().enabled == true) {
						c.collider.GetComponent<PropHealth>().Hurt(damage);
					}
				}
				if (c.collider.GetComponent<BossObjectiveHealth>() != null) {
					c.collider.GetComponent<BossObjectiveHealth>().Hurt(damage);
				}
				if (c.collider.GetComponent<BossHealth>() != null && c.collider.GetComponent<BossObjectiveManager>().opening) {
					c.collider.GetComponent<BossHealth>().Hurt(damage);
					BossElementalDamage(damageType, c.collider.GetComponent<BossHealth>());
				}
			}
		}
	}

	//model for cone AOE attack
	void ConeAttack(int damage, int damageType, float coneAngle, float range) {
		Collider[] hits = Physics.OverlapSphere(transform.position, range);		//get a list of everything within range
		foreach (Collider hit in hits) {
			if (hit.tag == "Enemy" && hit.isTrigger == false) {		//narrow the list down to the ones we want
				Vector3 check = hit.transform.position-transform.position;		
				float angle = Vector3.Angle(transform.TransformDirection(Vector3.forward)*-1, check);
				//Debug.Log(hit.name+"at angle of "+angle);
				if (angle <= coneAngle*0.5f) {		//check to make sure which ones fall within the flames
					//Debug.Log(hit.name+"can be hit at"+angle);
					if (hit.GetComponent<EnemyHealth>() != null) {
						hit.GetComponent<EnemyHealth>().Hurt(damage);
						ElementalDamage(damageType, hit.GetComponent<EnemyHealth>());
					}

					if (hit.collider.GetComponent<PropHealth>() != null) {
						if (hit.collider.GetComponent<PropHealth>().enabled == true) {
							hit.collider.GetComponent<PropHealth>().Hurt(damage);
						}
					}

					if (hit.GetComponent<BossObjectiveHealth>() != null) {
						hit.GetComponent<BossObjectiveHealth>().Hurt(damage);
						BossObjectiveElementalDamage(damageType, hit.GetComponent<BossObjectiveHealth>());
					}

					if (hit.GetComponent<BossHealth>() != null) {
						hit.GetComponent<BossHealth>().Hurt(damage);
						BossElementalDamage(damageType, hit.GetComponent<BossHealth>());
					}
				}
			}
		}
	}

	void ElementalDamage(int damageType, EnemyHealth eh) {
		if (damageType == eh.weakness) {	//first check if the enemy is weak to the attack's damage
			Debug.Log("He's weak");
			if (damageType == 1) {
				eh.burning = true;
				//Debug.Log("On fire");
			}
			else if (damageType == 2) {
				eh.electric = true;
			}
			else if (damageType == 3) {
				eh.flung = true;
			}
		}
	}

	void BossObjectiveElementalDamage(int damageType, BossObjectiveHealth boh) {
		if (damageType == boh.weakness) {	//first check if the enemy is weak to the attack's damage
			Debug.Log("He's weak");
			if (damageType == 1) {
				boh.burning = true;
				//Debug.Log("On fire");
			}
			else if (damageType == 2) {
				boh.electric = true;
			}
		}
	}

	void BossElementalDamage(int damageType, BossHealth bh) {
		if (damageType == bh.weakness) {	//first check if the enemy is weak to the attack's damage
			Debug.Log("He's weak");
			if (damageType == 1) {
				bh.burning = true;
				//Debug.Log("On fire");
			}
			else if (damageType == 2) {
				bh.electric = true;
			}
		}
	}

	IEnumerator Cooldown(float time) {
		yield return new WaitForSeconds(time);
		attackCooldown = false;
	}

	IEnumerator Cooldown2(float time) {
		yield return new WaitForSeconds(time);
		attackCooldown2 = false;
	}

	IEnumerator Cooldown3(float time) {
		yield return new WaitForSeconds(time);
		attackCooldown3 = false;
	}

	IEnumerator Cooldown4(float time) {
		yield return new WaitForSeconds(time);
		attackCooldown4 = false;
	}

	IEnumerator Cooldown5(float time) {
		yield return new WaitForSeconds(time);
		attackCooldown5 = false;
	}

	IEnumerator Cooldown6(float time) {
		yield return new WaitForSeconds(time);
		attackCooldown6 = false;
	}

	IEnumerator Cooldown7(float time) {
		yield return new WaitForSeconds(time);
		attackCooldown7 = false;
	}

	IEnumerator Cooldown8(float time) {
		yield return new WaitForSeconds(time);
		attackCooldown8 = false;
	}
}